import 'reflect-metadata';
export declare class JSONObject extends Object {
    private set;
    private get;
    constructor(json: any);
    static validate(code: (object: any, key: string, value: any) => void): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static union<T>(values: Array<T>): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static map(newKey: string): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    private static isOptional;
    private static jsonKeys;
    private static preprocess;
    private validateNumeric;
    static gt(value: number): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static gte(value: number): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static lt(value: number): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static lte(value: number): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static eq(value: any): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static ne(value: any): {
        (target: Function): void;
        (target: Object, propertyKey: string | symbol): void;
    };
    static passthrough(target: any, key: string): void;
    static required(target: any, key: string): void;
    static optional(target: any, key: string): void;
}
export declare function validate(code: (object: any, key: string, value: any) => void): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function union<T>(values: Array<T>): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function required(target: any, key: string): void;
export declare function optional(target: any, key: string): void;
export declare function map(jsonKey: string): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function passthrough(target: any, key: string): void;
export declare function gt(value: number): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function gte(value: number): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function lt(value: number): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function lte(value: number): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function eq(value: any): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare function ne(value: any): {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
